# `Localize.Message.Print`
[🔗](https://github.com/elixir-localize/localize/blob/v0.39.0/lib/localize/message/print.ex#L1)

Converts a MessageFormat 2 AST back to its canonical string form.

Used by `Localize.Message.canonical_message/2`.

# `to_string`

```elixir
@spec to_string(list() | tuple(), Keyword.t()) :: String.t()
```

Converts a parsed MF2 AST back to a canonical message string.

### Arguments

* `ast` is a parsed MF2 message AST as returned by
  `Localize.Message.Parser.parse/1`.

* `options` is a keyword list of options (currently unused
  but reserved for future use).

### Returns

* A canonical message string.

---

*Consult [api-reference.md](api-reference.md) for complete listing*
